"use strict";
const CLASS_NAME = "productProvider";
const initSequelize = require('../services/dbServices');

class productProvider {
    constructor(skipInitDb) {
        if (skipInitDb === true) {
            this.db = {};
        } else {
            this.db = initSequelize
        }
    }

    async getByCode(code) {
        const self = this;

        return await self.db.product.findOne({
            raw: true,
            where: code

        }).then(res => {
            return res;
        }).catch(err => {
            console.log(err)
        })

    }

    async getAll(currentPage, pageSize, sort, dir) {
        const self = this;

        return await self.db.product.findAndCountAll({
            limit: pageSize,
            offset: (currentPage - 1) * pageSize || 0,
            order: [
                [sort, dir]
            ],
            raw: true,
        }).then(res => {

            return res;
        }).catch(err => {
            console.log(err)
        })

    }


    async post(body) {
        const self = this;

        return await self.db.product.create(body)
            .then(res => {
                return res;
            })
            .catch(err => {
                console.log(err)
            })
    }

    async put(body, code) {
        const self = this;

        return await self.db.product
            .update({
                name: body.name,
                description: body.description,
                category: body.category,
                brand: body.brand,
                updated_at: body.updated_at,
                type: body.type
            }, { where: { code: code } })
            .then((result) => {
                return result;
            })
            .catch((err) => {
                console.log(err)
            });
    }


    async delete(code) {
        const self = this;

        return await self.db.product.destroy({
            where: { code: code }
        })
            .then(res => {
                return res;
            })
            .catch(err => {
                console.log(err)
            })
    }
}

module.exports = productProvider;