

const request = require('supertest');
const express = require('express');
const app =require('./index.js');

describe('API Products Endpoints', () => {
    it('should return listing with records', async () => {
      const res = await request(app).get('/api/products');
      expect(200)
      
    });
    it('should delete existing product', async () => {
      const res = await request(app).delete('/api/products/P005');
      expect(res.status);
      
    });

    it('should update existing product', async () => {
      const res = await request(app).put('/api/products/P003')
        .send({
          description: '*NULL*',
        });
      expect(res.status);
     
    });


    it('should create new product', async () => {
      const res = await request(app).post('/api/products').send({
          code: 'P101',
          name: 'Tall Basket',
          category: 'Home Decoration',
          brand: null,
          type: null,
          description: 'The next super product of the year.',
        });
      expect(res.status);
     
    });

}
)

module.exports = test;